<pools>
  <div class="wrapper">
    <!-- <div id="swap-form">
      <div class="section options">
        <span class={ state.position == 'long' ? 'long option active' : 'long option' } onclick={ switchPosition }>Long</span>
        <span class="divider">/</span>
        <span class={ state.position == 'short' ? 'long option active' : 'long option' } onclick={ switchPosition }>Short</span>
      </div>
    </div> -->

    <div class="filters">
      <div class="filter-section">
        <div class="filter">
          <label>Total volume >=</label>
          <input type="number" id="volume-min" placeholder="min" value="10000">
        </div>

        <div class="filter">
          <label>Liquidity >=</label>
          <input type="number" id="liquidity-min" placeholder="min"  value="10000">
        </div>
      </div>

      <div class="filter-section">
        <div class="filter">
          <label>Tx count >=</label>
          <input type="number" id="tx-min" placeholder="min"  value="100">
        </div>

        <div class="filter">
          <label>Pool launched since (days)</label>
          <input type="number" id="launched-days" placeholder="days ago" value="3">
        </div>
      </div>

      <button onclick={ loadPools }>SEARCH UNISWAP POOLS</button>
    </div>

    <table class="results">
      <tr>
        <th onclick={ () => this.sortBy('symbol') }>Symbol</th>
        <th onclick={ () => this.sortBy('liquidity') }>Liquidity ($)</th>
        <th onclick={ () => this.sortBy('volume') }>Volume ($)</th>
        <th onclick={ () => this.sortBy('vlRatio') }>Vol/Liq</th>
        <th onclick={ () => this.sortBy('txCount') }>Tx count</th>
        <th onclick={ () => this.sortBy('launchedDays') }>Days active</th>
        <th></th>
      </tr>
      <tr each={ pool in state.pools }>
        <td><a href="https://uniswap.info/token/{ pool.tokenAddress }" target="_blank">{ pool.symbol }</a></td>
        <td>{ pool.liquidity }</td>
        <td>{ pool.volume }</td>
        <td>{ pool.vlRatio }</td>
        <td>{ pool.txCount }</td>
        <td>{ pool.launchedDays }</td>
        <td><a href="https://twitter.com/search?q=%24{ pool.symbol }&src=typed_query&f=live" target="_blank" class="no-underline">🔍</a></td>
      </tr>
    </table>
  </div>

  <script>
    export default {

      config: {
        foo: 'bar',
      },

      state: {
        volume: { },
        liquidity: { },
        tx: { },
        launchedDays: { },
        pools: []
      },

      onMounted(props, state) {
        this.loadPools()
      },

      trunc(input, maxLength) {
        if (input.length > maxLength) {
            return input.substring(0, maxLength) + '...';
        }
        return input;
      },

      sortBy(column) {

        var poolCount = this.state.pools.length
        if (poolCount == 0) { return }
        var firstEl = eval(`this.state.pools[0].${column}`).replace(/\D/g, '')
        var lastEl = eval(`this.state.pools[poolCount - 1].${column}`).replace(/\D/g, '')
        var newPools

        if (firstEl < lastEl) {
          newPools = this.state.pools.sort(function(a, b) {
            return parseInt(eval(`b.${column}`).replace(/\D/g, '')) - parseInt(eval(`a.${column}`).replace(/\D/g, ''))
          })
        } else {
          newPools = this.state.pools.sort(function(a, b) {
            return parseInt(eval(`a.${column}`).replace(/\D/g, '')) - parseInt(eval(`b.${column}`).replace(/\D/g, ''))
          })
        }

        this.update({ pools: newPools })
      },

      async loadPools() {
        let createdAt = Math.floor(Date.now() / 1000) - (parseInt(this.$('#launched-days').value) * 3600 * 24)

        const query = `
        {
          pairs(first: 100, where: {
            createdAtTimestamp_gte: ${createdAt},
            volumeUSD_gte: ${this.$('#volume-min').value},
            txCount_gte: ${this.$('#tx-min').value},
            reserveUSD_gte: ${this.$('#liquidity-min').value}
          }) {
            id
            token0 {
              id
              name
              symbol
              tradeVolumeUSD
            }
            token1 {
              id
              name
              symbol
              tradeVolumeUSD
            }
            volumeUSD
            txCount
            reserveUSD
            createdAtTimestamp
          }
        }`.replace(/(\r\n|\n|\r)/gm, "")

        var res = await fetch("https://tokenscan.herokuapp.com/https://api.thegraph.com/subgraphs/name/uniswap/uniswap-v2", {
          method: "POST",
          headers: {
            'Content-Type': 'application/json'
          },
          body: '{ "query": "' + query + '" }'
        })

        var jsonRes = await res.json()
        var pairs = Array.from(jsonRes.data.pairs)

        var newPools = pairs.map(item => {
            const container = {}

            var daysAgo = ((Math.floor(Date.now() / 1000) - parseInt(item.createdAtTimestamp)) / 3600 / 24).toFixed(1)
            primaryToken = [item.token0, item.token1].sort(function(a, b) { return parseInt(a.tradeVolumeUSD) - parseInt(b.tradeVolumeUSD)})[0]

            container.symbol = this.trunc(primaryToken.symbol, 10)
            container.liquidity = Math.round(parseInt(item.reserveUSD)).toLocaleString()
            container.volume = Math.round(parseInt(item.volumeUSD)).toLocaleString()
            container.vlRatio = (item.volumeUSD / item.reserveUSD).toFixed(1)
            container.txCount = Math.round(parseInt(item.txCount)).toLocaleString()
            container.launchedDays = daysAgo
            container.tokenAddress = primaryToken.id

            return container
        }).sort(function(a, b) { return parseInt(b.volume.replace(/\D/g, '')) - parseInt(a.volume.replace(/\D/g, '')) })

        this.update({ pools: newPools })
      },

      switchDirection() {
        var direction = (this.state.swapDirection == "BUY") ? "SELL" : "BUY"

        this.update({
          inputAmount: this.outputAmount(),
        })
      }
    }
  </script>
</pools>